/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.routes

import de.steamwar.sql.TeamTeilnahme
import io.ktor.http.*
import io.ktor.server.application.*
import io.ktor.server.request.*
import io.ktor.server.response.*
import io.ktor.server.routing.*

fun Route.configureEventTeams() {
    route("/teams") {
        get {
            val event = call.receiveEvent()
                ?: return@get
            call.respond(TeamTeilnahme.getTeams(event.eventID).map { ResponseTeam(it) })
        }
        put {
            val event = call.receiveEvent()
                ?: return@put
            val team = call.receive<List<Int>>()
            team.forEach {
                TeamTeilnahme.teilnehmen(it, event.eventID)
            }
            call.respond(HttpStatusCode.NoContent)
        }
        delete {
            val event = call.receiveEvent()
                ?: return@delete
            val team = call.receive<List<Int>>()
            team.forEach {
                TeamTeilnahme.notTeilnehmen(it, event.eventID)
            }
            call.respond(HttpStatusCode.NoContent)
        }
    }
}